rom_header
	dc.l	$FFFFF0	; Initial stack pointer value
	dc.l	segaromstart	; Start of program
	dc.l	ignore_handler	; Bus error
	dc.l	ignore_handler	; Address error
	dc.l	ignore_handler	; Illegal instruction
	dc.l	ignore_handler	; Division by zero
	dc.l	ignore_handler	; CHK exception
	dc.l	ignore_handler	; TRAPV exception
	dc.l	ignore_handler	; Privilege violation
	dc.l	ignore_handler	; TRACE exception
	dc.l	ignore_handler	; Line-A emulator
	dc.l	ignore_handler	; Line-F emulator
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Spurious exception
	dc.l	ignore_handler	; IRQ level 1
	dc.l	ignore_handler	; IRQ level 2
	dc.l	ignore_handler	; IRQ level 3
	dc.l	ignore_handler	; IRQ level 4 (horizontal retrace interrupt)
	dc.l	ignore_handler	; IRQ level 5
	dc.l	interupt6	; IRQ level 6 (vertical retrace interrupt)  60 times per second
	dc.l	ignore_handler	; IRQ level 7
	dc.l	ignore_handler	; TRAP #00 exception
	dc.l	ignore_handler	; TRAP #01 exception
	dc.l	ignore_handler	; TRAP #02 exception
	dc.l	ignore_handler	; TRAP #03 exception
	dc.l	ignore_handler	; TRAP #04 exception
	dc.l	ignore_handler	; TRAP #05 exception
	dc.l	ignore_handler	; TRAP #06 exception
	dc.l	ignore_handler	; TRAP #07 exception
	dc.l	ignore_handler	; TRAP #08 exception
	dc.l	ignore_handler	; TRAP #09 exception
	dc.l	ignore_handler	; TRAP #10 exception
	dc.l	ignore_handler	; TRAP #11 exception
	dc.l	ignore_handler	; TRAP #12 exception
	dc.l	ignore_handler	; TRAP #13 exception
	dc.l	ignore_handler	; TRAP #14 exception
	dc.l	ignore_handler	; TRAP #15 exception
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved)
	dc.l	ignore_handler	; Unused (reserved) 64*4
	dc.b	'SEGA GENESIS    '	;16 bytes consol name
	dc.b	'(C)company      '	;16 bytes company name
	dc.b	'Hello World                                     '	;48 bytes game name
	dc.b	'Hello World                                     '	;48 bytes internal name
	dc.b	'Sept 4,2023   '	;14 bytes version number
	dc.w	$ffff	; 2 bytes Checksum can be corrected later 398 dec word
	dc.b	'J               '	;16 bytes io support
	dc.l	segaromstart	; Start address of ROM 4bytes
	dc.l	segaromend	; End address of ROM 4bytes
	dc.l	$FF0000	; Start address of RAM ram 4 bytes
	dc.l	$FFFFFF	; End address of RAM 4 bytes
	dc.b	$52,$41,$f8,$20	;4 bytes save ram enabled
	dc.l	$200001	;4 bytes save ram start
	dc.l	$20FFFF	;4 bytes save ram end
	dc.l	$00000000	; Unused modem 12bytes
	dc.l	$00000000	;
	dc.l	$00000000	; Unused modem end
	dc.b	'                                        '	; Notes (unused) 40 bytes padding
	dc.b	'JUE             '	;16 bytes country codes
